mediator = require 'mediator'

# adapter for the Routing object of the FosJsRoutingbundle
module.exports = class SymfonyRouter

  # transforms a Symfony route '/foo/{bar}' into a chaplin route 'foo/:bar'
  generateMatch: (routename) ->

    # 'Routing' is an object generated by the FOSJsRoutingBundle
    route = Routing.getRoute(routename)
    url = ''
    params = []

    for token in route.tokens
      if token[0] == 'text'
        url = token[1].slice(1)
        continue
      if token[0] == 'variable' and token[1] != '.'
        params.push(token[3])

    for param in params
      url += '/:' + param

    url = Routing.getBaseUrl() + '/' + url

    # strip any trailing slashes
    if url.endsWith('/')
      url = url.substr(0, url.length - 1)

    # remove leading slashes
    if url.beginsWith('/')
      url = url.replace('/', '')

    url


  generate: (name, params) =>
    url = Routing.generate(name, params)
    if url.endsWith('/')
      url = url.substr(0, url.length - 1)

    url